<?xml version="1.0" encoding="utf-8" standalone="no"?>

<!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.4//EN"
                      "http://docbook.org/xml/4.4/docbookx.dtd">

<book id="phpwebapp_manual">
  <title>The phpWebApp Manual</title>
  <bookinfo>
    <author>
      <firstname>Dashamir</firstname>
      <surname>Hoxha</surname>
      <affiliation>
        <address>
          <email>dashohoxha@users.sf.net</email>
        </address>
      </affiliation>
    </author>
    <abstract>
      <para>This manual is intended to help the developers of web applications that are based on phpWebApp. It describes in details the components and features of the framework.</para>
    </abstract>
    <keywordset>
      <keyword>PHP</keyword>
      <keyword>web</keyword>
      <keyword>application</keyword>
      <keyword>framework</keyword>
    </keywordset>
    <legalnotice>
      <para>Copyright (C) 2005 Dashamir Hoxha. Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License, Version 1.1 or any later version published by the Free Software Foundation; with no Invariant Sections, with no Front-Cover Texts, and with no Back-Cover Texts. A copy of the license is included in the section entitled "GNU Free Documentation License."</para>
    </legalnotice>
  </bookinfo>
  <chapter id="introduction">
    <title>Introduction</title>
    <para/>
    <section id="about-phpwebapp">
      <title>What is phpWebApp</title>
      <para><emphasis>phpWebApp</emphasis> is an application framework for building PHP web applications based on relational databases. It separates the graphical design and layout of the application from the logic of the application by using templates. It also provides a kind of event-based programing model (similar to that used in Visual Basic and other visual languages), object-oriented structure of the application, easy interface to database, code re-usability, etc.  It can be used to construct easily and efficiently eCommerce applications, eGovernment applications, eContent applications and any kind of web applications. </para>
    </section>
    <section id="features">
      <title>phpWebApp Features</title>
      <para>Some of the features of the <emphasis>phpWebApp</emphasis> framework, and the advantages and benefits of using it for building web applications, are these: </para>
      <itemizedlist>
        <listitem>
          <para> The framework uses a kind of template system which separates the layout from the logic of the application, so a graphical designer can easily improve the layout of the application without getting messed with the logic and without having to understand it. It makes easier the work of both the graphical designer and the programmer. The framework also separates the JavaScript code and the CSS code from the HTML code and the DB queries from the PHP code. </para>
        </listitem>
        <listitem>
          <para> The framework gives the possibility to divide a page into several parts which can be used in other pages as well. This makes the user interface of the application (the layout, the graphical part) more structured and easier to understand and maintain and makes easier the work of the graphical designer. </para>
        </listitem>
        <listitem>
          <para> For the framework, a web application is like a state machine, which can be represented and described by one or more state chart diagrams. Each page of the application that is displayed represents the application in a certain state. Clicking to a link causes a transition to another state of the application. The state of the application is kept in the so-called \emph{state variables}, which are similar to session variables. This simplifies the design and the implementation of web applications. </para>
        </listitem>
        <listitem>
          <para> The framework supports an event-based programming model. When a transition from one state of the application to another happens, it may trigger an event as well, which is handled by a function (event handler). It is implemented by building on top of CGI another level of communication between browser and server. The event-based programming model makes the logic of the application easy to build, understand and maintain, and makes easy the work of the web programmer. </para>
        </listitem>
        <listitem>
          <para> The framework gives to the web programmers the possibility to create web components (called WebBox-es). They have their own user interface (HTML+CSS code), client side behavior (JavaScript code), server side behavior (PHP code), state variables, events, event handlers, etc. Each component can be made almost 100\% self contained and independent from the other parts of the application, and it can be a state machine on its own.The big state machine of the application is a composition of the state machines of its components. This can reduce dramatically the complexity of a web application; instead of having to build a huge monolithic state machine for the whole application, we can build several small state sub-machines and compose them. </para>
        </listitem>
        <listitem>
          <para> Since the components are independent from the rest of the application, they can be very easily reused in other web applications. So, the framework provides code re-usability, which means that if you have constructed something once, you don't have to re-construct it again when you need it another time, but reuse the existing one. </para>
        </listitem>
        <listitem>
          <para> The framework brings closer the client-side and the server-side logic of a web application. E.g. the state variables are available and can be accessed both on the client side (JS code) and on the server side (PHP code). </para>
        </listitem>
        <listitem>
          <para>The framework simplifies the interaction of the application with the database. It also makes it almost database independent. This means that in case that you decide to change the database on which your application is based (e.g. switching from MySQL to Oracle), then the application itself doesn't need to be changed at all, it will work all the same. </para>
        </listitem>
        <listitem>
          <para> An application based on the framework is easy to maintain (debug, improve, extend, etc.). So, the framework also facilitates an iterative and incremental development approach for web application projects. </para>
        </listitem>
        <listitem>
          <para> The framework supports <emphasis>internationalization</emphasis> (i18n) and <emphasis>localization</emphasis> (l10n), based on standard GNU gettext tools. This means that a web application can be translated easily in other languages. </para>
        </listitem>
        <listitem>
          <para>Another thing is that phpwebapp offers good debugging features, which makes easier the development. Without debugging, software development would be a nightmare, isn't it. </para>
        </listitem>
      </itemizedlist>
    </section>
    <section id="why-not-php">
      <title>Why Not Use Plain PHP</title>
      <para>Constructing a web application with PHP or any similar scripting language is usually much more difficult than constructing a desktop application (e.g. using VB, VC++, KDevelopper, etc.). It is because it has inherently some bad sides and weak points which can be observed in most of the web applications. Some of these problems and difficulties are discussed below. </para>
      <section id="mixing-codes">
        <title>Mixing HTML, CSS, JavaScript, PHP, SQL codes</title>
        <para>Suppose that we have constructed a web application with PHP. If we inspect the code inside one of the files of the application, what we usually see is HTML code, JavaScript code, CSS code, PHP code, SQL code etc. all jammed together. This kind of mixing many languages inside the same file is a really bad thing, for these reasons: </para>
        <itemizedlist>
          <listitem>
            <para><emphasis>It makes the editing of the application very difficult.</emphasis> Most of the editors have code colorizing features, automatic indentation features, etc. for many languages, in order to simplify editing and to make it easy. But when they are faced with such a mix of languages, very often they get confused. As a result, such features become useless, and even they become harmful, because they may colorize wrongly or indent wrongly. </para>
          </listitem>
          <listitem>
            <para><emphasis>It makes the maintenance of the application very difficult.</emphasis> It is very difficult for somebody else to try to read, to understand and to modify such a code, and even for the author of the code himself (after some time has passed). </para>
          </listitem>
          <listitem>
            <para><emphasis>Makes difficult the team work.</emphasis> Suppose that a web application is constructed by a team that is composed of PHP programmers, who construct the server side logic of the application, web designers (HTML+CSS) who create the look and feel of the application, JavaScript programmers who construct the client side logic of the application, and DB specialists who construct the database and the queries. In this case it is very difficult for any one of them to make modifications in a big file that has lots of unfamiliar code to them, without making any mistake. Take for example the web designer, it is very difficult for him to change the look and layout of a web page that is tightly interwoven with PHP code. </para>
          </listitem>
          <listitem>
            <para><emphasis>Increases the complexity of web applications.</emphasis> Different from the previous example, suppose now that a web application is constructed by one or more programmers and each of them is responsible for a certain part of the application. In this case each of them has to have good skills in all of them: PHP, HTML, CSS, JavaScript, database, etc. This is difficult to be achieved and it increases the complexity and the difficulties of constructing a web application. </para>
          </listitem>
        </itemizedlist>
        <para>It is clear that such a mix of codes is a bad thing and a bad practice and it must be avoided as much as possible. </para>
        <para>The HTML syntax offers a possibility to take out the JavaScript code and the CSS code in separate files. It is like this: </para>
        <programlisting>
          <![CDATA[<script language="javascript" src="file.js"></script>
<link rel="stylesheet" href="file.css" type="text/css" />
]]>
        </programlisting>
        <para>However there is no standard way to clearly separate the HTML, PHP and SQL codes. You can try to keep the degree of mixing of HTML and PHP code at a minimum level by carefully designing the application. E.g. you can place all the PHP code unrelated to the HTML generation (the code that contains the logic of the application) in a separate file and keep the file that generates the HTML page as lean as possible. </para>
        <para>A better solution to separate the HTML and PHP codes is to use a template engine. It uses templates for generating the final HTML page. Each template is a pure HTML file, which also has some slots or variables in it. The values of these variables are calculated by the PHP code and they are passed to the engine. Then the engine reads the templates, replaces the variables by their values and thus generates an HTML page which is sent to the browser. </para>
      </section>
      <section id="no-persistent-vars">
        <title>From one page to the next, global variables are lost</title>
        <para>Different from the desktop applications, web applications are discrete. This means that one view (page) of the application has almost no connection to the next one. This is because global variables are lost and each page has to be constructed from the scratch. </para>
        <para>Each web application can be thought as a state machine. Each time you see in the browser the application at a certain state. When you click something inside the page, then the application goes to another state and it sends to the browser another page. However, oddly, web applications cannot keep their state in their global variables because from one request of the browser to the other they are lost. This is inherent in all web applications because the HTTP protocol is a stateless protocol. </para>
        <para>Usually, web applications try to overcome this problem by using session variables, cookies, parameters in the CGI query, etc. However there is no easy and standard way and this often results in overhead (because you have to write special code for storing and retrieving these variables), increased complexity, etc. </para>
      </section>
      <section id="lack-of-modularity">
        <title>Lack of modularity</title>
        <para>Big web applications are usually huge and monolithic, not only in code but also in the programing logic. So they have all the problems that are caused by the lack of modularity: they have high complexity, it is difficult to maintain or improve them, the code cannot be reused easily in other applications, etc. </para>
        <para>By careful design and implementation, a web application can be made more modular, and usually big web applications do it (otherwise it would be too difficult to build and maintain them). However this modularization is different from one application to the other, it is specific to the web application itself and cannot be reused or applied to another web application, because it is not enough general  <footnote><para>If it is somehow general, so that it can be applied for a certain domain of web applications, then it would be a framework or engine, and the application would not be considered to be built on plain PHP.</para></footnote> . </para>
      </section>
    </section>
    <section id="other-frameworks">
      <title>Other Frameworks and Templating Systems</title>
      <para>From the above section it is clear that using a framework or engine or template system is usually better than using plain PHP, for building a web application. To make a comparison with desktop applications, you can build a windows application even using the C Win32 API, but it is much more easy and convenient to use VB or VC++ (which are in fact just frameworks, based on C API, for building windows applications). To build a windows application using the C API would be just like using Assembly for writing a program. Similarly, using a framework for building a web application usually is more convenient then using plain PHP. Of course it has some overhead, because you will have to learn how to use the framework first, before starting to build the application. </para>
      <para>There are a lot of frameworks or template systems that can be used for building a web application. Just make a search at <ulink url="http://sourceforge.net/search/?type=soft">sourceforge.net</ulink> for "web application framework" or for "template system" and you will discover a lot of them. <emphasis>phpWebApp</emphasis> is one of them. </para>
    </section>
  </chapter>
  <chapter id="templates">
    <title>Templates</title>
    <para>Templates are XHTML files which can contain some additional tags and some variables. These tags and variables are processed by the framework and are replaced with HTML code when the web page is created. These templates allow the web page designer to work almost independently from the database designer and from the PHP programmer that implements the logic of the application. </para>
    <para>Some of the extra tags that can be used in templates are: &lt;Include&gt;, &lt;If&gt;, &lt;Repeat&gt;, &lt;WebBox&gt;, &lt;Recordset&gt;, etc. They can be mixed and nested without problem (except for some special cases). </para>
    <section id="xhtml">
      <title>The XHTML Standard</title>
      <para>The main (root) template of the page should start like this: 
    <programlisting><![CDATA[<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="EN">
]]></programlisting>
because if no DOCTYPE is defined, the parser will have problems with reckognizing entities (&amp;nbsp; &amp;amp; etc.), and there may be any other problems as well. </para>
      <para>For the other templates (which are included from another one), these headers shoud not be added, because the parser will add them automatically, so that they become well-formed xml and are parsed successfully. The headers that will be added to the other templates will be a copy of the headers of the main template. </para>
      <para>If the included templates do have the prolog and the root element, it has no effect in the generated page, because the framework will just discard them. On the other hand, it is not practical to include the prolog and the root element in each template; some of them may be just small templates, like this one: 
    <programlisting><![CDATA[<tr>
  <td>...</td>
</tr>
]]></programlisting></para>
      <para>The templates must be well-formed XML files. This is required by the framework because it uses an XML parser to parse them, and if a template is not well-formed, the parser will not be able to parse it and will display an error. E.g. <emphasis>&lt;br/&gt;</emphasis> must be used instead of <emphasis>&lt;br&gt;</emphasis> , <emphasis>&lt;img ... /&gt;</emphasis> instead of <emphasis>&lt;img ...&gt;</emphasis> , etc. (see <ulink url="http://www.w3schools.com/xhtml/xhtml_html.asp">XHTML vs HTML</ulink> for more details about these). </para>
      <para>Except the usual XHTML tags, the templates can also contain extra elements (tags), which are reckognized and processed by the framework. For the framework it doesn't matter the case (upper/lower) of these tags, however it is good to keep them in lowercase, since all the other XHTML tags are required to be lowercase (by the XHTML standard). </para>
      <para>So, the templates may not be fully compliant to the XHTML standard, due to the additional things that are supported by the framework. However, the page that the framework generates from them and which is sent to the browser, is a valid XHTML page. </para>
      <para>The framework preserves any CDATA marks that are found in the templates (this means that they still apear in the resulting page). This is important because the javascript code in an XHTML page needs to be written inside a CDATA section and, if the framework did not preserve the CDATA marks, the resulting page would not be a valid XHTML page. </para>
      <para>Another issue related to XML is this: each xml parser is required to process the entities: &amp;amp; &amp;lt; &amp;gt; &amp;quot; and &amp;apos; and to return the corresponding character instead of the entity itself. For this reason, in order to include e.g. an ampersand in a page, it is not enough to write it in template as <emphasis>&amp;amp;</emphasis> but it should be written as <emphasis>&amp;amp;amp;</emphasis> . The same goes for &amp;amp;lt;, &amp;amp;quot;, etc. </para>
    </section>
    <section id="tpl-comments">
      <title>Comments</title>
      <para>Template comments are just like usual XHTML comments, but they are discarded by the framework when the template is processed. They are denoted by adding a diesis after the opening mark: </para>
      <programlisting>
        <![CDATA[<!--# 
  Such comments are not included in the XHTML file 
  that is generated and sent to the browser.
-->

<!--
  Usual XHTML comments (like this one) are passed to
  the XHTML file that is generated from the template.
-->
]]>
      </programlisting>
    </section>
    <section id="tpl-include">
      <title>Include</title>
      <para>The <emphasis>&lt;Include&gt;</emphasis> element is used to include a template inside another template: 
    <programlisting><![CDATA[<include src="templates/header.html" />
<include src="{{content_file}}" />
<include src="{{./}}edit/cluster_edit.html" />
]]></programlisting></para>
      <para>It provides to the application modularity and more flexibility. The modularity consists in breaking a large page into smaller templates, and in using the same template in several pages. </para>
      <para>The flexibility consists in this: the file that will be included may be a variable (or may contain variables), so different files may be included in the same place of the page, according to the logic of the application. The variables used here are evaluated when the template is parsed, so they should be parse-time variables (see later about what this means). </para>
      <tip>
        <para>Note in the last example the variable <emphasis>{{#./}}</emphasis> . It is defined automatically by the framework and it allways keeps the path of the current directory (the directory of the template that contains the <emphasis>&lt;include&gt;</emphasis> ). This allows the usage of relative paths in the "src" attribute, and it makes the application more flexible. So, the directory containing the template can be renamed or moved to another location, however the paths of the included files need not to be changed since they are relative to the current directory.</para>
      </tip>
    </section>
    <section id="tpl-if">
      <title>If</title>
      <para>The content of the element <emphasis>&lt;If&gt;</emphasis> is included in the resulting page conditionally. If the value of the attribute "condition" is true, then it is included, otherwise it is skiped. </para>
      <programlisting>
        <![CDATA[<if condition="!{{admin}}">
  <a class="button" href="javascript:edit()">Edit</a>
</if>
]]>
      </programlisting>
      <para>The value of the condition is calculated as a PHP expression (after the template variables have been replaced). The evaluation of the condition is done at the render time (when the page is generated, see later about parse and render), so they should be render-time variables. </para>
      <tip>
        <para>Use <emphasis>!=</emphasis> instead of <emphasis>&lt;&gt;</emphasis> in the expression of the condition, because the xml parser complains about the characters &lt; and &gt; inside the value of an attribute.

  <programlisting>This is wrong: <![CDATA[<if condition="'{CurrPage}'<>'{PrevPage}'">...</if>]]></programlisting><programlisting>This is right: <![CDATA[<if condition="'{CurrPage}'!='{PrevPage}'">...</if>]]></programlisting></para>
      </tip>
    </section>
    <section id="tpl-repeat">
      <title>Repeat</title>
      <para>The <emphasis>&lt;Repeat&gt;</emphasis> element is used to repeat a part of the template several times: 
    <programlisting><![CDATA[<table>
  <repeat rs="rs_id">
    <tr><td>{{field_name}}</td></tr>
  </repeat>
</table>
]]></programlisting></para>
      <para>It is useful e.g. for constructing tables, when you want to add a row for each record in the result of a DB query. The attribute <emphasis>rs</emphasis> is the id of a recordset<footnote><para>A recordset is an object that contains the results of a DB query.</para></footnote> . The body of the &lt;repeat&gt; will be repeated for each record of the recordset. Each time, the fields of the record will be used as template variables for it. </para>
      <para>In case that the recordset is empty, the content of the element <emphasis>&lt;IfEmpty&gt;</emphasis> (if present) is displayed instead of the body. The <emphasis>&lt;Separator&gt;</emphasis> element is displayed between two repetitions of the body of the &lt;Repeat&gt;. It is optional. </para>
      <para>The elements &lt;IfEmpty&gt; and &lt;Separator&gt; can be placed anywhere inside the &lt;Repeat&gt;. Everything inside the &lt;Repeat&gt; element and outside the elements &lt;IfEmpty&gt; and &lt;Separator&gt; is considered as body of the &lt;Repeat&gt; and is processed for each record of the recordset. To make it more readable, the tag <emphasis>&lt;RepeatBody&gt;</emphasis> may be used, but it is just "syntactic sugar" and doesn't effect anything. It is optional and usually is omitted. </para>
      <programlisting>
        <![CDATA[<table>
  <repeat rs="rs_id">
    <ifempty>
      <!--# <IfEmpty> is included in the page in case
          that recordset specified has no records #-->
      <tr>
        <td>No articles found!</td>
      </tr>
    </ifempty>
    <repeatbody>
      <!--#
          Here comes the part that is repeated
          for each record in the recordset. The tag
          <RepeatBody> is optional and may be omitted
      #-->
      <tr>
        <td> {{TI}} </td>
        <td> {{AU}} </td>
        . . .
      </tr>
    </repeatbody>
    <separator>
      <!--# <Separator> is processed between
          two repetitions of the <RepeatBody> #-->
      <tr><td colspan="3"> <hr width="90%" /> </td></tr>
    </separator>
  </repeat>
</table>
]]>
      </programlisting>
      <para>The value of the "rs" attribute can also contain variables, like this: 
    <programlisting><![CDATA[<repeat rs="{{rs_id}}"> . . . </repeat>]]></programlisting>
This allows a repeat block to use different queries in different cases (according to the logic of the program). These variables are evaluated in render time (it should be assigned in the function onParse(), or it should be a state variable or global variable). </para>
    </section>
    <section id="tpl-indent">
      <title>Identation</title>
      <para>The framework tries to indent the generated XHTML page as well as possible. If you view the source of a page that is generated by the framework, usually you will see a well-indented XHTML code that is easy to read and to copy/paste. </para>
      <para>The framework does not modify the indentation of the HTML code inside the templates, however it tries to keep the indentation of the &lt;include&gt; elements. That is, all the included code is indented with the same indentation as the &lt;include&gt; element. </para>
      <para>Most of the time this is good, however sometimes it has undesirable effects. For example, for the XHTML elements &lt;pre&gt;, &lt;xmp&gt; and &lt;textarea&gt;, it would add unwanted extra spaces at the begining of each line. This would be wrong because their contents is 'preformated' and it should not be modified. The framework corrects this by reckognizing these tags and adding no extra indentation to their contents. </para>
      <para>Sometimes it may be usefull to add no indentation to a part of a template. This can be done by including it inside the &lt;unindented&gt; tag, like this: 
    <programlisting><![CDATA[<unindented>
{{file_revision}}
</unindented>
]]></programlisting>
It will turn off the extra indentation that is done by the framework. </para>
    </section>
    <section id="tpl-db">
      <title>Database</title>
      <para/>
      <section id="tpl-db-recordset">
        <title>Recordset, Query, dbCommand</title>
        <para>The <emphasis>&lt;Recordset&gt;</emphasis> element can be used to define a DB query, which can be executed later by the framework and the result can be used to construct a <emphasis>Recordset</emphasis> object. It can be used like this: </para>
        <programlisting>
          <![CDATA[<Recordset id="rs-id">
  <Query>
    SELECT field1, {{field_name}}
    FROM table-name
    WHERE id = '{{id}}'
  </Query>
</Recordset>
]]>
        </programlisting>
        <para>Each &lt;recordset&gt; has a unique ID. Later, when we use this recordset (e.g. in &lt;repeat&gt;) we refer to it by this ID. </para>
        <para>It also has a &lt;Query&gt; element, which contains the query to be executed. The query may contain variables, which are replaced at the time that the query is executed. </para>
        <tip>
          <para>If there is any <emphasis>smaller-than</emphasis> operator (&lt;)  in the contents of a &lt;Query&gt; element, then either replace
      it by &amp;lt; or enclose the query in CDATA marks.</para>
        </tip>
        <para>There is also a <emphasis>&lt;dbCommand&gt;</emphasis> element, which is in fact identical to &lt;recordset&gt; but is usually used for insert/update/delete queries (which usually do not give a result other that successful/unsuccessful and cannot be used to construct a <emphasis>Recordset</emphasis> object). </para>
      </section>
      <section id="tpl-db-type">
        <title>Types of Recordsets</title>
        <para>The &lt;Recordset&gt; can also have a "type" attribute: 
    <programlisting><![CDATA[<Recordset id="rs-id" type="rs-type">]]></programlisting></para>
        <para>This attribute can have one of the values: (EditableRS | StaticRS | DynamicRS | PagedRS). The default value (if the attribute is missing) is 'EditableRS'. </para>
        <para>An 'EditableRS' is a recordset that can be modified from the PHP code. The programer can retrive the results of a query from DB and then modify them, or start with an empty RS and fill it programatically. It makes possible to use recordsets even for results that don't come from DB. </para>
        <para>A 'StaticRS' is a recordset that is opened only once in a page. It is more efficient for recordsets that are used many times in a page without changing (e.g. when a recordset fills a listbox and this listbox is used many times in the page). An editable RS is also static, so a recordset is by default static (if the "type" attribute is missing). This type needs to be declared explicitly only when for some reason we don't want the recordset to be editable (it just gets the results from the DB and it cannot be modified from the PHP code). </para>
        <para>A 'DynamicRS' is a recordset that executes its query each time that it is opened. Since the query can contain {{variables}} and the variables of the query are evaluated and replaced just before the execution, the result of the query can be different each time that it is executed. It is useful e.g when we have a &lt;repeat&gt; nested inside another &lt;repeat&gt;: the recordset of the inner &lt;repeat&gt; will be opened and refreshed for each record of the outer recordset, and since it can contain variables that are defined by the outer &lt;repeat&gt;, it can have different results each time that it is repeated. </para>
        <para>A 'PagedRS' is a recordset that divides the results of the query into pages of certain size and retrives from DB only one page of them. A page is a group of consecutive records. All the pages (except the last one) have the same number of records and they form a partition of all the records of the query. If the recordset is of type 'PagedRS' then the attribute 'recs_per_page' must be defined as well, which specifies the size of the page. This type of recordset is usually used to display queries that have many results which usually cannot fit in a single HTML page. </para>
      </section>
      <section id="tpl-db-rsnavig">
        <title>rsNavig</title>
        <para>Suppose that we have a &lt;repeat&gt; which is connected to a paged recordset. Then just records of one page (the current page) of the recordset are displayed in the XHTML page. In order to navigate to the other pages of the recordset we need to know what is the next page, previous page, last page, etc. </para>
        <para>n this case the element <emphasis>&lt;rsNavig&gt;</emphasis> is useful: 
    <programlisting><![CDATA[<rsNavig rs="paged-rs-id"> ... </rsNavig>]]></programlisting></para>
        <para>The attribute "rs" of &lt;rsNavig&gt; contains the id of a <emphasis>PagedRS</emphasis> recordset. The framework gets from the recordset some navigation variables and makes them available in the scope of &lt;rsNavig&gt;. These variables are: </para>
        <itemizedlist>
          <listitem>
            <para>{{#FirstRec}} -- the number of the first record of the page </para>
          </listitem>
          <listitem>
            <para>{{#LastRec}} -- the number of the last record of the page </para>
          </listitem>
          <listitem>
            <para>{{#AllRecs}} -- the number of all records that can be retrieved by the query </para>
          </listitem>
          <listitem>
            <para>{{#CurrPage}} -- current page of records that is retrieved </para>
          </listitem>
          <listitem>
            <para>{{#NextPage}} -- the number of the next page </para>
          </listitem>
          <listitem>
            <para>{{#PrevPage}} -- the number of the previous page </para>
          </listitem>
          <listitem>
            <para>{{#LastPage}} -- the number of the last page </para>
          </listitem>
        </itemizedlist>
        <para>In the following section there is an example of using &lt;rsNavig&gt;. </para>
        <section id="tpl-db-rsnavig-xmp">
          <title>Example</title>
          <para>&lt;rsNavig&gt; is usually used in the header or footer of a paged list, in order to provide navigation to the other pages of a recordset. Here is an example of the footer of such a list: </para>
          <programlisting>
            <![CDATA[<rsnavig rs="tcards_rs">
<table class="list_footer" border="0" cellspacing="0">
  <tr>
    <td width="25%">
      Found: {{AllRecs}} Technological Cards
    </td>
    <td width="25%">
      Page {{CurrPage}} of {{LastPage}}
    </td>
    <td>
      <if condition="'{{CurrPage}}' > '{{PrevPage}}'">
        <a href="javascript:SendEvent('tcardList','next','page=1')">
          &amp;lt;&amp;lt;First
        </a>
        &nbsp;&nbsp;
        <a href="javascript:SendEvent('tcardList','next','page={{PrevPage}}')">
          &amp;lt;Prev
        </a>
        &nbsp;&nbsp;
      </if>
      <if condition="'{{NextPage}}' > '{{CurrPage}}'">
        <a href="javascript:SendEvent('tcardList','next','page={{NextPage}}')">
          Next&amp;gt;
        </a>
        &nbsp;&nbsp;
        <a href="javascript:SendEvent('tcardList','next','page={{LastPage}}')">
          Last&amp;gt;&amp;gt;
        </a>
        &nbsp;&nbsp;
      </if>
    </td>
  </tr>
</table>
</rsnavig>
]]>
          </programlisting>
        </section>
      </section>
    </section>
    <section id="tpl-components">
      <title>Components</title>
      <para/>
      <section id="tpl-webbox">
        <title>WebBox</title>
        <para>A WebBox is a template which has also some PHP code associated with it. It is a self-contained and independent template which can be easily included in other pages or in other applications. In fact, it may also have some JavaScript code, CSS stylesheets, SQL queries etc., associated with it. </para>
        <para>It is denoted by the tag <emphasis>&lt;WebBox&gt;</emphasis> and it has an ID attribute: 
    <programlisting><![CDATA[<webbox id="box-id">
  <!-- content of WebBox -->
</webbox>
]]></programlisting>
The identifier must be different for each WebBox used in the application. </para>
        <para>A WebBox is defined inside a template file and the TPL code of the WebBox is inside the &lt;WebBox&gt; tag (is the content of the &lt;WebBox&gt; element). </para>
      </section>
      <section id="tpl-webclass">
        <title>WebClass, WebObject</title>
        <para><emphasis>&lt;WebClass&gt;</emphasis> defines a web class and <emphasis>&lt;WebObject&gt;</emphasis> declares an object of the class: </para>
        <programlisting>
          <![CDATA[<WebClass ID="className" Path="path/to/className.php">
    <Parameter name="param1" default="default value" />
    <Parameter name="param2" />
  <!--# . . . . . . . . . . . . . . . . #-->
  <!--# the template of the web class   #-->
  <!--# . . . . . . . . . . . . . . . . #-->
</WebClass>

<WebObject Class="className" name="wObj1" param1="value1" param2="value2" />
<WebObject Class="className" name="wObj2" param2="value2" />
<WebObject Class="className" name="wObj3" param1="{{nr}}+1" param2="red" />
]]>
        </programlisting>
        <para>The WebClass does not produce any output in the resulting XHTML page. A WebObject uses the template of its class. </para>
        <para>The "path" attribute of the &lt;WebClass&gt; declares the path of the file that contains the PHP code of the WebClass. It is optional, and if it is not given, the current folder is searched for the file <filename>className.php</filename> (the folder of the template that contains the &lt;WebClass&gt; definition). </para>
        <para>The &lt;Parameter&gt; elements declare the names and optionally the default values of the parameters of the webobjects. These parameters can be used inside the template of the webclass like template variables, e.g. {{#param1}}. If a parameter doesn't get a value in the &lt;WebObject&gt; declaration, then its default value is used (if it doesn't have a default value, then it is handled like an undefined variable). When a &lt;WebObject&gt; is rendered, the value of the parameters is evaluated as a mixed expression (a PHP expression that contains {{#template variables}}). </para>
        <para>When several objects of the same class are declared, the template of the webclass is repeated for each of them. The webclass designer should take this into account when building the webclass. E.g. if there is such an &lt;input&gt; in the webclass template: 
    <programlisting><![CDATA[<input type="text" name="staff">]]></programlisting>
There will be several such inputs in the HTML code, and its value cannot be accessed like this: <emphasis>document.form.staff.value</emphasis></para>
      </section>
    </section>
    <section id="tpl-misc">
      <title>Misc</title>
      <para/>
      <section id="tpl-var">
        <title>Var</title>
        <para><emphasis>&lt;Var&gt;</emphasis> elements declare variables that can be used anywhere in the template in the current scope and in the scopes inside it: 
    <programlisting><![CDATA[<var name="SUM">({{field1}} + {{field2}} + {{field3}})</var>
]]></programlisting></para>
        <para>They are identified by their name, and their value is calculated using their content as an expression. The value of the expression is calculated in this way: first, any template variable inside it is found and replaced, then the resulting string is evaluated as a PHP expression. </para>
        <para>The value of the expression is evaluated at the time that the template is rendered. So, if a variable is inside a &lt;repeat&gt; element, then it may have different values for different iterations: 
    <programlisting><![CDATA[<var name="ROW_COLOR">
  ({{CurrentRowNr}}%2 ? "grey" : "white")
</var>
<tr class="{{ROW_COLOR}}"> . . . </tr>
]]></programlisting></para>
      </section>
      <section id="tpl-tpl">
        <title>Template</title>
        <para>The <emphasis>&lt;template&gt;</emphasis> element has no effect other then defining a new scope. E.g the variable defined below will be available only inside the body of &lt;template&gt;: 
    <programlisting><![CDATA[<template>
  <var name="test"> . . . </var>
  . . .
</template>
]]></programlisting></para>
      </section>
      <section id="tpl-xmp">
        <title>Example</title>
        <para>The <emphasis>&lt;example&gt;</emphasis> tag can be used for examples about the framework templates. It can be used like this: 
    <programlisting><![CDATA[<example style="border: 1px solid #eeeeee;">  test
  <b>test</b>
  {{test}}
  <include src="{{content_html}}" />
</example>
]]></programlisting></para>
        <para>It is converted by the framework to an &lt;xmp&gt; element, like this: 
    <programlisting><![CDATA[<xmp style="border: 1px solid #eeeeee;">  test
  <b>test</b>
  {{test}}
  <include src="{{content_html}}" />
</ xmp>
]]></programlisting></para>
      </section>
    </section>
  </chapter>
  <chapter id="transitions">
    <title>Transitions</title>
    <para>A transition is the move of the application from one state to another (usually from one page to another). A state of the application is composed of a certain template file and some session variables (session variables are persistent variables of the application whose lifetime may be as long as the time that the application is active). A transition is usually triggered by a client-side event in the browser, such as: clicking a link, pressing a button, submiting a form, timeout of a javascript timer, etc. </para>
    <caution>
      <para>Although the transitions seem quite similar to the HTML links,
they are actually very different. An HTML link requests a page from
a web-server, while a transition requests a page of the application
from the framework. So, all the pages of the application should 
refer to each-other only by using transitions, and to the external 
pages (pages outside the application) only by using links. If a page
of the application refers to another page of the application by a
link, this may break the consistency of the application. Such a 
mistake may happen if the page has an HTML form, because this form
usually submits to its action, by not using a transition. To overcome
this, we should declare the form like this:

  <programlisting><![CDATA[<form name="form1" onSubmit="return false;">    or
<form name="form1" onSubmit="on_submit(); return false;">
]]></programlisting></para>
    </caution>
    <section id="goto">
      <title>How is Done a Transition</title>
      <para>In the phpWebApp a transition is done by calling the JavaScript function <emphasis>GoTo()</emphasis> which is declared by the framework itself, e.g. 
    <programlisting>GoTo('page1.html');</programlisting>
In this case, the <emphasis>GoTo()</emphasis> function sends a request to the web-server for another page. This request is processed by the framework, which loads the template <filename>page1.html</filename> (in the folder TPL of the application) processes it and sends it to the browser. </para>
      <para>If a path is specified for the template, e.g. 
    <programlisting>GoTo('folder1/page1.html');</programlisting>
then this path is found in the folder TPL. If the page that is to be loaded is the same as the current page (e.g. we are in page <filename>page1.html</filename> and we want to load again the page <filename>page1.html</filename>), then this syntax can be used: 
    <programlisting>GoTo('thisPage');</programlisting>
the framework remembers itself what is the current page and loads it again. This syntax is handy in the case of generic webboxes which may be included in several pages, and they don't know in which page they will be included. </para>
      <para>Usually, before making a transition you need to make some validations (e.g. when the user fills a form and submits it to the application). These data validations can be done in the client-side by using a javascript function. For example: 
    <programlisting><![CDATA[<a href="javascript: on_link()"> Link </a>
<input type="button" value="Button" onClick="on_button()">
<form onSubmit="on_submit(); return false;">
]]></programlisting>
The functions <emphasis>on_link()</emphasis>, <emphasis>on_button()</emphasis> and <emphasis>on_submit()</emphasis> usually do some client-side validations and error checkings and then, if everything is OK, they cause a transition by calling the function <emphasis>GoTo()</emphasis>. </para>
    </section>
    <section id="sending-variables">
      <title>Sending PHP Variables to the Application</title>
      <para>Usual links can send variables to application (on the server), like this: 
    <programlisting><![CDATA[<a href="page1.php?var1=val1&var2=val2"> Link </a>
]]></programlisting></para>
      <para>Similarly, a transition as well can send variables to the application, like this: 
    <programlisting><![CDATA[<a href="javascript: GoTo('page1.html?var1=val1&var2=val2')"> Link </a>
]]></programlisting></para>
      <para>These variables will be declared as PHP global variables by the framework and may be used in the PHP code of the application. </para>
      <tip>
        <para>The use of these global variables is discouraged, because there are better ways to send variables to the application.</para>
      </tip>
      <note>
        <title>Sending an Event to the Application</title>
        <para>An important variable that is sent to the application almost in each transition is the variable <emphasis>event</emphasis> . This variable sends to the application a server-side event that should be handled by the application. The format of an event variable is like this:

  <programlisting>event=targetBox.eventName(arg1=val1;arg2=val2;arg3=val3)</programlisting>
When the framework gets the variable <emphasis>event</emphasis> , it builds an object of class <emphasis>Event</emphasis> and forwards it to the appropriate WebBox for handling. (For more details on events see <xref linkend="events"/> .)</para>
      </note>
    </section>
  </chapter>
  <chapter id="webbox">
    <title>WebBox-es</title>
    <para>A WebBox is a template which has also its own PHP code, which handles its server-side logic. It is an almost self-contained and independent template which can be easily included in other pages or in other projects. </para>
    <para>Each page of a WebApp should contain at least a webbox, unless it is very simple (doesn't have server-side logic). A webbox can be composed of other webboxes. WebBox-es are the components that are used to build a web application. (Component in OOP is called a class that has only one object). </para>
    <para>It is denoted by the tag <emphasis>&lt;WebBox&gt;</emphasis> and it has an ID attribute: 
    <programlisting><![CDATA[  <webbox id="boxId">
      <!-- content of WebBox -->
  </webbox>
]]></programlisting></para>
    <para>The identifier of the box is very important and must be different for each box used in the application. </para>
    <section id="webbox-files">
      <title>The Files Related to a WebBox</title>
      <para>The files related to the webox <emphasis>boxId</emphasis> are: <filename>boxId.php</filename> , <filename>boxId.db</filename> , <filename>boxId.js</filename> , <filename>boxId.css</filename> , etc. All of them are optional, only the template (HTML) of a WebBox is required. They are included automatically by the framework, if they exist in the same folder with the webbox. Other related files may be subtemplates, images etc., which are not included automatically by the framework. </para>
      <caution>
        <para>All the files of a WebBox (.php, .js, .css, .db, etc.) must have the same name as the ID of the WebBox, otherwise the framework will not reckognize them as belonging to this WebBox.</para>
      </caution>
      <itemizedlist>
        <listitem>
          <para>The file <filename>boxId.js</filename> contains the javascript functions of the webox (which is just usual JS code). It is included automatically by the framework at the &lt;head&gt; of the page. The framework looks for the file <filename>boxId.js</filename> in the same folder with the WebBox; if it exists there, then the framework includes a line like this in the &lt;head&gt; of the page: 
      <programlisting><![CDATA[<script type="text/javascript" language="javascript" src="path/to/boxId.js"></script>]]></programlisting></para>
        </listitem>
        <listitem>
          <para>Similarly, the file <filename>boxId.css</filename> contains any stylesheet (CSS code) that is specific to the WebBox. If the file <filename>boxId.css</filename> exists, the framework includes in the &lt;head&gt; of the page a line like this: 
      <programlisting><![CDATA[<link type="text/css" rel="stylesheet" src="path/to/boxId.css" />]]></programlisting></para>
        </listitem>
        <listitem>
          <para>The file <filename>boxId.db</filename> contains the &lt;dbCommand&gt; and &lt;Recordset&gt; elements that are used in the PHP code or in the template. If it exists, it is included automatically by the framework, before the template of the WebBox is parsed. (See the documentation about interacting with the database for more details). </para>
        </listitem>
        <listitem>
          <para>The file <filename>boxId.php</filename> contains the PHP code of the WebBox. Similarly, if it exists, it is included automatically by the framework, before the template of the WebBox is parsed. (See the following section, <xref linkend="webbox-phpcode"/> , for more details.) </para>
        </listitem>
      </itemizedlist>
      <para>Some tips: </para>
      <tip>
        <para>You can place more than one WebBox in a template file, however it is recomended to place each WebBox in a separate template, without other HTML code that does not belong to it. It is recomended to name this template <emphasis>boxId.html</emphasis> .</para>
      </tip>
      <tip>
        <para>A WebBox (and its related files) can be placed in any directory, together with other WebBox-es and templates; the framework has no restrictions about this. However, it is recomended to place all the files related to a WebBox in a separate folder, named <emphasis>boxId</emphasis> , for better readability and structure of the application.</para>
      </tip>
    </section>
    <section id="webbox-phpcode">
      <title>The PHP Code of a WebBox</title>
      <para>The PHP code of a WebBox is placed in the file <filename>boxId.php</filename> which is in the same folder as the template containing the WebBox. Most of the PHP code and the logic of the WebBox is encapsulated inside a PHP class name <emphasis>boxId</emphasis> , which extends the interface (or the abstract class) WebObject, like this: 
    <programlisting>class boxId extends WebObject { . . . }</programlisting>
This makes the PHP code of the application more object-oriented and better organized. </para>
      <para>The class <emphasis>boxId</emphasis> can override the functions of the interface WebObject: eventHandler($event), onParse(), onRender(), etc., or can define other functions that can be used inside these functions. It can also define handle functions for each of the WebBox events. </para>
      <para>The functions of WebObject that can be overriden by the WebBox are these: </para>
      <itemizedlist>
        <listitem>
          <para><programlisting>function init()</programlisting>
Called only the first time that the WebBox is loaded (only once in a session). Can be used to initialize the state variables of the WebBox.     </para>
        </listitem>
        <listitem>
          <para><programlisting>function onParse()</programlisting>
Called by the framework before the WebBox is parsed. It is usually used to give value to some template variables that affect the parsing. E.g. if we have this line in a template: 
      <programlisting><![CDATA[  <include src="{{content_file}}" />]]></programlisting>
then the variable <emphasis>{{#content_file}}</emphasis> must have a value before this line is parsed, and usually this value is given in the onParse() function, according to the application logic.     </para>
        </listitem>
        <listitem>
          <para><programlisting>function afterParse()</programlisting>
Called by the framework after the WebBox is parsed.     </para>
        </listitem>
        <listitem>
          <para><programlisting>function onRender()</programlisting>
Called by the framework before the WebBox is rendered. It is usually used to add {{#variables}} that are used in the template.     </para>
        </listitem>
        <listitem>
          <para><programlisting>function eventHandler($event)</programlisting>
Called by the framework to handle an event of the WebBox that does not have a specific event handler. It typically has a switch statement on the variable '$event-&gt;name', and performs some actions depending on the case. It also can extract and use the arguments of the event from the '$event-&gt;args'.     </para>
        </listitem>
      </itemizedlist>
      <para>The class may also contain functions like this: 
    <programlisting><![CDATA[  function on_eventName($event_args)
]]></programlisting>
for each event of the WebBox, where <emphasis>eventName</emphasis> is the name of the event, and the parameter $event_args is an associative array that contains the event arguments and their values. The value of the arguments can be accessed like this: 
    <programlisting><![CDATA[  $var_value = $event_args['var_name'];
]]></programlisting>
Or, all the arguments can be extracted in the current scope like this (see the PHP function <emphasis>extract()</emphasis> ): 
    <programlisting>  extract($event_args);</programlisting></para>
    </section>
    <section id="webbox-statevars">
      <title>State Vars of the WebBox</title>
      <para>Each webox can have its own state (session/persistent) vars. </para>
      <para>Usually, the initialization of the state vars of the webbox is done in the function <emphasis>init()</emphasis> , using the function <emphasis>WebObject::addSVar()</emphasis> or <emphasis>WebObject::addSVars()</emphasis> , like this: 
    <programlisting>  $this-&gt;addSVar('var_name', $var_value);
  $this-&gt;addSVars($associated_array);
</programlisting></para>
      <important>
        <para>A state var is initialized only once! This means that in case that addSVar() is called for a state variable that already exists (is already initialized), then it will not change its value.</para>
      </important>
      <para>Inside the class (PHP code) of the webbox, its state vars can be modified and accessed like this: 
    <programlisting>  $this-&gt;setSVar('var_name', $var_value);
  $this-&gt;setSVars($associated_array);
  $var_value = $this-&gt;getSVar('var_name');
  $assoc_arr = $this-&gt;getSVars();
</programlisting></para>
      <para>Outside the class of the webbox <emphasis>boxId</emphasis> , its state variables can be accessed like this: 
    <programlisting>  WebApp::setSVar('boxId-&gt;var_name', $var_value);
  $var_value = WebApp::getSVar('boxId-&gt;var_name');
</programlisting></para>
      <para>It is also possible to initialize a state variable of a webbox from outside of the webbox (e.g. from the init() of the parent webbox), like this: 
    <programlisting>  WebApp::addSVar('boxId-&gt;var_name', $var_value);
</programlisting></para>
      <para>All the state variables of a webbox can be retrieved as an associative array: 
    <programlisting>  $vars = WebApp::getSVars('boxId');
  extract($vars);
</programlisting></para>
      <para>The state vars of the webbox can be accessed from the JS code as well, like this: 
    <programlisting>  session.setVar('boxId-&gt;var_name', var_value);
  var_value = session.getVar('boxId-&gt;var_name');
</programlisting></para>
      <para>The state variables of the webbox can be used in the template of the webbox in the usual way: {{#var_name}} and they are valid only in the scope of this webbox (and shadow any other {{#variables}} with the same name that are defined in the enclosing scopes. In case that a state variable of a webbox needs to be used in a template outside its own webox, then its full name should be used, like this: <emphasis>{{#boxId-&gt;var_name}}</emphasis></para>
      <para>If the constant DEBUG_STATEVARS in <filename>config/const.Debug.php</filename> is set to <emphasis>true</emphasis> , then the framework outputs at the end of the page the state variables for each webbox and their values, which helps to debug them. </para>
    </section>
    <section id="webbox-processing">
      <title>How a WebBox is Processesed</title>
      <para>In order to use the webbox features correctly, it is usefull to know the steps that the framework follows for calling the PHP code of the WebBox. In general, the framework constructs the HTML page (that is sent to the browser) in two phases: first it parses (loads) all the relevant templates and builds a structure in memory, then it uses these templates to render (generate) the HTML page. The following list describes these steps according to the order that they happen: </para>
      <orderedlist numeration="arabic">
        <listitem>
          <para>At the time that the framework is about to load (parse) the WebBox, it includes the file <filename>boxId.php</filename> (if it exists). </para>
        </listitem>
        <listitem>
          <para>If this is the first time that this WebBox is loaded (in this session), then it calls the function <emphasis>init()</emphasis> , which can be used to initialize the state variables of the WebBox. </para>
        </listitem>
        <listitem>
          <para>If there is an event sent to this WebBox, the framework calls the corresponding event handler <emphasis>on_eventName($event_args)</emphasis> . If such a function is not defined, it calls the general event handler of the WebBox: <emphasis>eventHandler($event)</emphasis> . </para>
        </listitem>
        <listitem>
          <para>The framework calls the function <emphasis>onParse()</emphasis> which may define any parse-time template variables. </para>
        </listitem>
        <listitem>
          <para>The framework parses the template (HTML code) of the WebBox and loads it in a structure in memory. Any parse-time variables can be used during the parse. </para>
        </listitem>
        <listitem>
          <para>The function <emphasis>afterParse()</emphasis> is called. </para>
        </listitem>
        <listitem>
          <para>After all WebBox-es and templates of the application are parsed, the framework starts to render (generate) the HTML page that is sent to the browser. </para>
        </listitem>
        <listitem>
          <para>The function <emphasis>onRender()</emphasis> is called before starting to render the template of the WebBox. Any <emphasis>render-time</emphasis> template variables are defined here. </para>
        </listitem>
        <listitem>
          <para>Finally, the template of the WebBox is rendered and any {{#variables}} in it are replaced by their value. </para>
        </listitem>
      </orderedlist>
    </section>
  </chapter>
  <chapter id="webclass-es">
    <title>WebClass-es and WebObject-s</title>
    <para>The concept of WebClass and WebObject is similar to the classes and objects in the OOP (Object-Oriented Programing). </para>
    <section id="webcl-template">
      <title>The Template Syntax</title>
      <para>The element &lt;WebClass&gt; defines a web class, but it by itself does not produce any HTML output in the rendered page. The element &lt;WebObject&gt; declares an object of the class and the content (the template) of the &lt;WebClass&gt; is used to render this object. They are used like this: </para>
      <programlisting>
        <![CDATA[    <webclass id="classId" path="path/to/classId.php">
            <parameter name="param1" default="default value" />
            <parameter name="param2" />
        <!--# . . . . . . . . . . . . . . . . #-->
        <!--# the template of the web class   #-->
        <!--# . . . . . . . . . . . . . . . . #-->
    </webclass>

    <webobject class="classId" name="wObj1" param1="value1" param2="value2" />
    <webobject class="classId" name="wObj2" param2="value2" />
    <webobject class="classId" name="wObj3" param1="{{nr}}+1" param2="red" />
]]>
      </programlisting>
      <para>The <emphasis>path</emphasis> attribute of the &lt;WebClass&gt; declares the path of the file that defines the PHP code of the WebClass. It is optional, and if it is not given, then the current folder (the folder of the template that contains the &lt;WebClass&gt; definition) is searched for the file <filename>classId.php</filename></para>
      <para>The &lt;Parameter&gt; elements declare the names and optionally the default values of the parameters of the webobjects. These parameters can be used inside the template of the webclass like template variables, e.g. {{#param1}}. If a parameter doesn't get a value in the &lt;WebObject&gt; declaration, then its default value is used (if it doesn't have a default value, then it is handled like an undefined variable). When a &lt;WebObject&gt; is rendered, the value of the parameters is evaluated as a <emphasis>mixed expression</emphasis> (a PHP expression that contains {{#template vars}}). </para>
      <caution>
        <para>When several objects of the same class are declared, the template of the webclass is repeated for each of them. The webclass designer should take this into account when building the webclass. E.g. if there is such an input in the webclass template:

  <programlisting><![CDATA[  <input type="text" name="staff">
]]></programlisting>
Then there will be several such inputs in the HTML code, and its value cannot be accessed like this:

  <programlisting>  document.form.staff.value</programlisting></para>
      </caution>
      <para>To help the webclass designers to avoid the problem described above, the framework declares for each webobject these variables: 
    <itemizedlist><listitem><para>{{#class_name}} -- the name of the class </para></listitem><listitem><para>{{#obj_name}} -- the name of the object </para></listitem><listitem><para>{{#obj_id}} -- the object id ('{{#class_name}}::{{#obj_name}}') </para></listitem><listitem><para>{{#obj_count}} -- count of the objects of the same class, starting from 1 </para></listitem></itemizedlist>
These vars can be used inside the template of the webclass, if the webclass designer needs them, e.g.: 
    <programlisting><![CDATA[  <input type="text" name="staff_{{obj_count}}">
]]></programlisting></para>
    </section>
    <section id="webcl-vars">
      <title>WebObject Variables</title>
      <para>When several objects of the same class are declared, the template of the webclass is repeated for each of them. The webclass designer should take this into account when building the webclass. E.g. if there is such an input in the webclass template: 
    <programlisting><![CDATA[  <input type="text" name="staff">
]]></programlisting>
Then there will be several such inputs in the HTML code, and its value cannot be accessed like this: 
    <programlisting>  document.form.staff.value</programlisting></para>
      <para>To help the webclass designers to avoid the problem described above, the framework declares for each webobject these variables: 
    <itemizedlist><listitem><para>{{#class_name}} -- the name of the class </para></listitem><listitem><para>{{#obj_name}} -- the name of the object </para></listitem><listitem><para>{{#obj_id}} -- the object id ('{{#class_name}}::{{#obj_name}}') </para></listitem><listitem><para>{{#obj_count}} -- count of the objects of the same class, starting from 1 </para></listitem></itemizedlist>
These vars can be used inside the template of the webclass, if the webclass designer needs them, e.g.: 
    <programlisting><![CDATA[  <input type="text" name="staff_{{obj_count}}">
]]></programlisting></para>
      <para>Other variables that can be used in the template of the webclass are its parameters, its state variables, and the variables that are declared in the PHP code (similar to WebBox-es). </para>
    </section>
    <section id="webcl-php">
      <title>The PHP Code</title>
      <para>The PHP code of the webclass <emphasis>&lt;WebClass ID="classId"&gt;</emphasis> is contained in the file <filename>classId.php</filename> . The framework includes it automatically, if it exists. This file defines a class named <emphasis>classId</emphasis> which extends the class <emphasis>WebObject</emphasis> , and which is very similar to the PHP code of a WebBox: </para>
      <programlisting>
        <![CDATA[<?
class classId extends WebObject
{
  . . . . .
}   
?>
]]>
      </programlisting>
      <para>The same as in the case of a WebBox, this class can override the functions of <emphasis>WebObject</emphasis> , which are called by the framework at certain moments during the time that the webobject is processed. </para>
      <para>These functions are: </para>
      <itemizedlist>
        <listitem>
          <para>init() -- called only the first time that a WebObject is loaded </para>
        </listitem>
        <listitem>
          <para>onParse() -- called before the template of the WebClass is parsed </para>
        </listitem>
        <listitem>
          <para>afterParse() -- called after the template of the WebClass is parsed </para>
        </listitem>
        <listitem>
          <para>onRender() -- called before the HTML of a WebObject is rendered </para>
        </listitem>
        <listitem>
          <para>on <emphasis>eventName($event</emphasis> args) -- called to handle an event of a WebObject </para>
        </listitem>
        <listitem>
          <para>eventHandler($event) -- generic event handler, if no special event handler exists </para>
        </listitem>
      </itemizedlist>
      <para>A WebObject can also have its own state variables, which are similar to the state variables of a WebBox. </para>
    </section>
    <section id="webcl-webbox">
      <title>WebBox-es</title>
      <para/>
    </section>
  </chapter>
  <chapter id="events">
    <title>Events</title>
    <para/>
  </chapter>
  <chapter id="variables">
    <title>Variables</title>
    <para/>
  </chapter>
  <chapter id="statevars">
    <title>State Variables</title>
    <para/>
  </chapter>
  <chapter id="database">
    <title>Database</title>
    <para/>
  </chapter>
  <chapter id="recordsets">
    <title>Recordsets</title>
    <para/>
  </chapter>
  <chapter id="app-struct">
    <title>Application Structure</title>
    <para/>
  </chapter>
  <chapter id="l10n">
    <title>I18n and L10n</title>
    <para/>
  </chapter>
  <chapter id="reusable">
    <title>Reusable Components</title>
    <para/>
  </chapter>
  <chapter id="appendix">
    <title>Appendix</title>
    <section id="GNU-FDL">
      <title>GNU Free Documentation License</title>
      <para><indexterm role="cp" significance="normal"><primary>FDL, GNU Free Documentation License</primary></indexterm>Version 1.2, November 2002
<screen>Copyright (C) 2000,2001,2002 Free Software Foundation, Inc.
59 Temple Place, Suite 330, Boston, MA  02111-1307, USA

Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.
</screen></para>
      <orderedlist continuation="continues" numeration="arabic" inheritnum="ignore">
        <listitem>
          <para>
PREAMBLE
</para>
          <para>
The purpose of this License is to make a manual, textbook, or other
functional and useful document <firstterm>free</firstterm> in the sense of freedom: to
assure everyone the effective freedom to copy and redistribute it,
with or without modifying it, either commercially or noncommercially.
Secondarily, this License preserves for the author and publisher a way
to get credit for their work, while not being considered responsible
for modifications made by others.
</para>
          <para>
This License is a kind of "copyleft", which means that derivative
works of the document must themselves be free in the same sense.  It
complements the GNU General Public License, which is a copyleft
license designed for free software.
</para>
          <para>
We have designed this License in order to use it for manuals for free
software, because free software needs free documentation: a free
program should come with manuals providing the same freedoms that the
software does.  But this License is not limited to software manuals;
it can be used for any textual work, regardless of subject matter or
whether it is published as a printed book.  We recommend this License
principally for works whose purpose is instruction or reference.
</para>
        </listitem>
        <listitem>
          <para>
APPLICABILITY AND DEFINITIONS
</para>
          <para>
This License applies to any manual or other work, in any medium, that
contains a notice placed by the copyright holder saying it can be
distributed under the terms of this License.  Such a notice grants a
world-wide, royalty-free license, unlimited in duration, to use that
work under the conditions stated herein.  The "Document", below,
refers to any such manual or work.  Any member of the public is a
licensee, and is addressed as "you".  You accept the license if you
copy, modify or distribute the work in a way requiring permission
under copyright law.
</para>
          <para>
A "Modified Version" of the Document means any work containing the
Document or a portion of it, either copied verbatim, or with
modifications and/or translated into another language.
</para>
          <para>
A "Secondary Section" is a named appendix or a front-matter section
of the Document that deals exclusively with the relationship of the
publishers or authors of the Document to the Document's overall
subject (or to related matters) and contains nothing that could fall
directly within that overall subject.  (Thus, if the Document is in
part a textbook of mathematics, a Secondary Section may not explain
any mathematics.)  The relationship could be a matter of historical
connection with the subject or with related matters, or of legal,
commercial, philosophical, ethical or political position regarding
them.
</para>
          <para>
The "Invariant Sections" are certain Secondary Sections whose titles
are designated, as being those of Invariant Sections, in the notice
that says that the Document is released under this License.  If a
section does not fit the above definition of Secondary then it is not
allowed to be designated as Invariant.  The Document may contain zero
Invariant Sections.  If the Document does not identify any Invariant
Sections then there are none.
</para>
          <para>
The "Cover Texts" are certain short passages of text that are listed,
as Front-Cover Texts or Back-Cover Texts, in the notice that says that
the Document is released under this License.  A Front-Cover Text may
be at most 5 words, and a Back-Cover Text may be at most 25 words.
</para>
          <para>
A "Transparent" copy of the Document means a machine-readable copy,
represented in a format whose specification is available to the
general public, that is suitable for revising the document
straightforwardly with generic text editors or (for images composed of
pixels) generic paint programs or (for drawings) some widely available
drawing editor, and that is suitable for input to text formatters or
for automatic translation to a variety of formats suitable for input
to text formatters.  A copy made in an otherwise Transparent file
format whose markup, or absence of markup, has been arranged to thwart
or discourage subsequent modification by readers is not Transparent.
An image format is not Transparent if used for any substantial amount
of text.  A copy that is not "Transparent" is called "Opaque".
</para>
          <para>
Examples of suitable formats for Transparent copies include plain
ascii without markup, Texinfo input format, LaTeX input
format, <acronym>SGML</acronym> or <acronym>XML</acronym> using a publicly available
<acronym>DTD</acronym>, and standard-conforming simple <acronym>HTML</acronym>,
PostScript or <acronym>PDF</acronym> designed for human modification.  Examples
of transparent image formats include <acronym>PNG</acronym>, <acronym>XCF</acronym> and
<acronym>JPG</acronym>.  Opaque formats include proprietary formats that can be
read and edited only by proprietary word processors, <acronym>SGML</acronym> or
<acronym>XML</acronym> for which the <acronym>DTD</acronym> and/or processing tools are
not generally available, and the machine-generated <acronym>HTML</acronym>,
PostScript or <acronym>PDF</acronym> produced by some word processors for
output purposes only.
</para>
          <para>
The "Title Page" means, for a printed book, the title page itself,
plus such following pages as are needed to hold, legibly, the material
this License requires to appear in the title page.  For works in
formats which do not have any title page as such, "Title Page" means
the text near the most prominent appearance of the work's title,
preceding the beginning of the body of the text.
</para>
          <para>
A section "Entitled XYZ" means a named subunit of the Document whose
title either is precisely XYZ or contains XYZ in parentheses following
text that translates XYZ in another language.  (Here XYZ stands for a
specific section name mentioned below, such as "Acknowledgements",
"Dedications", "Endorsements", or "History".)  To "Preserve the Title"
of such a section when you modify the Document means that it remains a
section "Entitled XYZ" according to this definition.
</para>
          <para>
The Document may include Warranty Disclaimers next to the notice which
states that this License applies to the Document.  These Warranty
Disclaimers are considered to be included by reference in this
License, but only as regards disclaiming warranties: any other
implication that these Warranty Disclaimers may have is void and has
no effect on the meaning of this License.
</para>
        </listitem>
        <listitem>
          <para>
VERBATIM COPYING
</para>
          <para>
You may copy and distribute the Document in any medium, either
commercially or noncommercially, provided that this License, the
copyright notices, and the license notice saying this License applies
to the Document are reproduced in all copies, and that you add no other
conditions whatsoever to those of this License.  You may not use
technical measures to obstruct or control the reading or further
copying of the copies you make or distribute.  However, you may accept
compensation in exchange for copies.  If you distribute a large enough
number of copies you must also follow the conditions in section 3.
</para>
          <para>
You may also lend copies, under the same conditions stated above, and
you may publicly display copies.
</para>
        </listitem>
        <listitem>
          <para>
COPYING IN QUANTITY
</para>
          <para>
If you publish printed copies (or copies in media that commonly have
printed covers) of the Document, numbering more than 100, and the
Document's license notice requires Cover Texts, you must enclose the
copies in covers that carry, clearly and legibly, all these Cover
Texts: Front-Cover Texts on the front cover, and Back-Cover Texts on
the back cover.  Both covers must also clearly and legibly identify
you as the publisher of these copies.  The front cover must present
the full title with all words of the title equally prominent and
visible.  You may add other material on the covers in addition.
Copying with changes limited to the covers, as long as they preserve
the title of the Document and satisfy these conditions, can be treated
as verbatim copying in other respects.
</para>
          <para>
If the required texts for either cover are too voluminous to fit
legibly, you should put the first ones listed (as many as fit
reasonably) on the actual cover, and continue the rest onto adjacent
pages.
</para>
          <para>
If you publish or distribute Opaque copies of the Document numbering
more than 100, you must either include a machine-readable Transparent
copy along with each Opaque copy, or state in or with each Opaque copy
a computer-network location from which the general network-using
public has access to download using public-standard network protocols
a complete Transparent copy of the Document, free of added material.
If you use the latter option, you must take reasonably prudent steps,
when you begin distribution of Opaque copies in quantity, to ensure
that this Transparent copy will remain thus accessible at the stated
location until at least one year after the last time you distribute an
Opaque copy (directly or through your agents or retailers) of that
edition to the public.
</para>
          <para>
It is requested, but not required, that you contact the authors of the
Document well before redistributing any large number of copies, to give
them a chance to provide you with an updated version of the Document.
</para>
        </listitem>
        <listitem>
          <para>
MODIFICATIONS
</para>
          <para>
You may copy and distribute a Modified Version of the Document under
the conditions of sections 2 and 3 above, provided that you release
the Modified Version under precisely this License, with the Modified
Version filling the role of the Document, thus licensing distribution
and modification of the Modified Version to whoever possesses a copy
of it.  In addition, you must do these things in the Modified Version:
</para>
          <orderedlist numeration="upperalpha" inheritnum="ignore" continuation="restarts">
            <listitem>
              <para>
Use in the Title Page (and on the covers, if any) a title distinct
from that of the Document, and from those of previous versions
(which should, if there were any, be listed in the History section
of the Document).  You may use the same title as a previous version
if the original publisher of that version gives permission.
  </para>
            </listitem>
            <listitem>
              <para>
List on the Title Page, as authors, one or more persons or entities
responsible for authorship of the modifications in the Modified
Version, together with at least five of the principal authors of the
Document (all of its principal authors, if it has fewer than five),
unless they release you from this requirement.
  </para>
            </listitem>
            <listitem>
              <para>
State on the Title page the name of the publisher of the
Modified Version, as the publisher.
  </para>
            </listitem>
            <listitem>
              <para>
Preserve all the copyright notices of the Document.
  </para>
            </listitem>
            <listitem>
              <para>
Add an appropriate copyright notice for your modifications
adjacent to the other copyright notices.
  </para>
            </listitem>
            <listitem>
              <para>
Include, immediately after the copyright notices, a license notice
giving the public permission to use the Modified Version under the
terms of this License, in the form shown in the Addendum below.
  </para>
            </listitem>
            <listitem>
              <para>
Preserve in that license notice the full lists of Invariant Sections
and required Cover Texts given in the Document's license notice.
  </para>
            </listitem>
            <listitem>
              <para>
Include an unaltered copy of this License.
  </para>
            </listitem>
            <listitem>
              <para>
Preserve the section Entitled "History", Preserve its Title, and add
to it an item stating at least the title, year, new authors, and
publisher of the Modified Version as given on the Title Page.  If
there is no section Entitled "History" in the Document, create one
stating the title, year, authors, and publisher of the Document as
given on its Title Page, then add an item describing the Modified
Version as stated in the previous sentence.
  </para>
            </listitem>
            <listitem>
              <para>
Preserve the network location, if any, given in the Document for
public access to a Transparent copy of the Document, and likewise
the network locations given in the Document for previous versions
it was based on.  These may be placed in the "History" section.
You may omit a network location for a work that was published at
least four years before the Document itself, or if the original
publisher of the version it refers to gives permission.
  </para>
            </listitem>
            <listitem>
              <para>
For any section Entitled "Acknowledgements" or "Dedications", Preserve
the Title of the section, and preserve in the section all the
substance and tone of each of the contributor acknowledgements and/or
dedications given therein.
  </para>
            </listitem>
            <listitem>
              <para>
Preserve all the Invariant Sections of the Document,
unaltered in their text and in their titles.  Section numbers
or the equivalent are not considered part of the section titles.
  </para>
            </listitem>
            <listitem>
              <para>
Delete any section Entitled "Endorsements".  Such a section
may not be included in the Modified Version.
  </para>
            </listitem>
            <listitem>
              <para>
Do not retitle any existing section to be Entitled "Endorsements" or
to conflict in title with any Invariant Section.
  </para>
            </listitem>
            <listitem>
              <para>
Preserve any Warranty Disclaimers.
  </para>
            </listitem>
          </orderedlist>
          <para>
If the Modified Version includes new front-matter sections or
appendices that qualify as Secondary Sections and contain no material
copied from the Document, you may at your option designate some or all
of these sections as invariant.  To do this, add their titles to the
list of Invariant Sections in the Modified Version's license notice.
These titles must be distinct from any other section titles.
</para>
          <para>
You may add a section Entitled "Endorsements", provided it contains
nothing but endorsements of your Modified Version by various
parties--for example, statements of peer review or that the text has
been approved by an organization as the authoritative definition of a
standard.
</para>
          <para>
You may add a passage of up to five words as a Front-Cover Text, and a
passage of up to 25 words as a Back-Cover Text, to the end of the list
of Cover Texts in the Modified Version.  Only one passage of
Front-Cover Text and one of Back-Cover Text may be added by (or
through arrangements made by) any one entity.  If the Document already
includes a cover text for the same cover, previously added by you or
by arrangement made by the same entity you are acting on behalf of,
you may not add another; but you may replace the old one, on explicit
permission from the previous publisher that added the old one.
</para>
          <para>
The author(s) and publisher(s) of the Document do not by this License
give permission to use their names for publicity for or to assert or
imply endorsement of any Modified Version.
</para>
        </listitem>
        <listitem>
          <para>
COMBINING DOCUMENTS
</para>
          <para>
You may combine the Document with other documents released under this
License, under the terms defined in section 4 above for modified
versions, provided that you include in the combination all of the
Invariant Sections of all of the original documents, unmodified, and
list them all as Invariant Sections of your combined work in its
license notice, and that you preserve all their Warranty Disclaimers.
</para>
          <para>
The combined work need only contain one copy of this License, and
multiple identical Invariant Sections may be replaced with a single
copy.  If there are multiple Invariant Sections with the same name but
different contents, make the title of each such section unique by
adding at the end of it, in parentheses, the name of the original
author or publisher of that section if known, or else a unique number.
Make the same adjustment to the section titles in the list of
Invariant Sections in the license notice of the combined work.
</para>
          <para>
In the combination, you must combine any sections Entitled "History"
in the various original documents, forming one section Entitled
"History"; likewise combine any sections Entitled "Acknowledgements",
and any sections Entitled "Dedications".  You must delete all
sections Entitled "Endorsements."
</para>
        </listitem>
        <listitem>
          <para>
COLLECTIONS OF DOCUMENTS
</para>
          <para>
You may make a collection consisting of the Document and other documents
released under this License, and replace the individual copies of this
License in the various documents with a single copy that is included in
the collection, provided that you follow the rules of this License for
verbatim copying of each of the documents in all other respects.
</para>
          <para>
You may extract a single document from such a collection, and distribute
it individually under this License, provided you insert a copy of this
License into the extracted document, and follow this License in all
other respects regarding verbatim copying of that document.
</para>
        </listitem>
        <listitem>
          <para>
AGGREGATION WITH INDEPENDENT WORKS
</para>
          <para>
A compilation of the Document or its derivatives with other separate
and independent documents or works, in or on a volume of a storage or
distribution medium, is called an "aggregate" if the copyright
resulting from the compilation is not used to limit the legal rights
of the compilation's users beyond what the individual works permit.
When the Document is included in an aggregate, this License does not
apply to the other works in the aggregate which are not themselves
derivative works of the Document.
</para>
          <para>
If the Cover Text requirement of section 3 is applicable to these
copies of the Document, then if the Document is less than one half of
the entire aggregate, the Document's Cover Texts may be placed on
covers that bracket the Document within the aggregate, or the
electronic equivalent of covers if the Document is in electronic form.
Otherwise they must appear on printed covers that bracket the whole
aggregate.
</para>
        </listitem>
        <listitem>
          <para>
TRANSLATION
</para>
          <para>
Translation is considered a kind of modification, so you may
distribute translations of the Document under the terms of section 4.
Replacing Invariant Sections with translations requires special
permission from their copyright holders, but you may include
translations of some or all Invariant Sections in addition to the
original versions of these Invariant Sections.  You may include a
translation of this License, and all the license notices in the
Document, and any Warranty Disclaimers, provided that you also include
the original English version of this License and the original versions
of those notices and disclaimers.  In case of a disagreement between
the translation and the original version of this License or a notice
or disclaimer, the original version will prevail.
</para>
          <para>
If a section in the Document is Entitled "Acknowledgements",
"Dedications", or "History", the requirement (section 4) to Preserve
its Title (section 1) will typically require changing the actual
title.
</para>
        </listitem>
        <listitem>
          <para>
TERMINATION
</para>
          <para>
You may not copy, modify, sublicense, or distribute the Document except
as expressly provided for under this License.  Any other attempt to
copy, modify, sublicense or distribute the Document is void, and will
automatically terminate your rights under this License.  However,
parties who have received copies, or rights, from you under this
License will not have their licenses terminated so long as such
parties remain in full compliance.
</para>
        </listitem>
        <listitem>
          <para>
FUTURE REVISIONS OF THIS LICENSE
</para>
          <para>
The Free Software Foundation may publish new, revised versions
of the GNU Free Documentation License from time to time.  Such new
versions will be similar in spirit to the present version, but may
differ in detail to address new problems or concerns.  See
http://www.gnu.org/copyleft/.
</para>
          <para>
Each version of the License is given a distinguishing version number.
If the Document specifies that a particular numbered version of this
License "or any later version" applies to it, you have the option of
following the terms and conditions either of that specified version or
of any later version that has been published (not as a draft) by the
Free Software Foundation.  If the Document does not specify a version
number of this License, you may choose any version ever published (not
as a draft) by the Free Software Foundation.
</para>
        </listitem>
      </orderedlist>
      <section id="addendum">
        <title>ADDENDUM: How to use this License for your documents
</title>
        <para>
To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and
license notices just after the title page:
</para>
        <para>
          <screen>
Copyright (C)  <varname>year</varname>  <varname>your name</varname>.
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2
or any later version published by the Free Software Foundation;
with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
Texts.  A copy of the license is included in the section entitled ``GNU
Free Documentation License''.
 </screen>
        </para>
        <para>
If you have Invariant Sections, Front-Cover Texts and Back-Cover Texts,
replace the "with...Texts." line with this:
</para>
        <para>
          <screen>
with the Invariant Sections being <varname>list their titles</varname>, with
the Front-Cover Texts being <varname>list</varname>, and with the Back-Cover Texts
being <varname>list</varname>.
 </screen>
        </para>
        <para>
If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.
</para>
        <para>
If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of
free software license, such as the GNU General Public License,
to permit their use in free software.
</para>
      </section>
    </section>
  </chapter>
</book>
